; Julio A. Rios
; May 2005
; rtproc.asm
;
; program code to implement NTSC video signal generation
; using wait instruction (addi $31, $0, [wait count])
; no loop for first section since there are only two iterations
; 
; assembled using gasm assembler
; provided with miniMIPS package
; CVS: http://www.opencores.org/cvsweb.shtml/minimips/

	org 0

	addi $20, $0, 80	; const width = 80
LOOP:	addi $31, $0, 96	; wait 96
	sw $0, 16388($0)	; 0x4004 VHSYNC
	addi $31, $0, 704	; wait 704
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 96	; wait 96
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 704	; wait 704
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 96	; wait 96
	sw $0, 16388($0)	; 0x4004 VHSYNC
	addi $31, $0, 704	; wait 704
	sw $0, 16386($0)	; 0x4002 HSYNC
; Vertical Back Porch
		; handle first line independently
	addi $31, $0, 96	; wait 96
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 704	; wait 704
	add $1, $0, $0	; i = 0
VBP:	addi $31, $0, 704	; wait 704
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 96 	; wait 96
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $1, $1, 1	; i++
	slti $2,$1, 31	; if i < 31
	bne $2, $0, VBP	;    goto VBP
; Vertical Active Region
	add $1, $0, $0	; row=0
ROWS:	add $2, $0, $0	; line=0
LINES:	addi $31, $0, 96	; wait 96
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 47	; wait 47
	sw $0, 16386($0)	; 0x4002 HSYNC
	add $3, $1, $0	; i = row * 80
	mult $3, $20		;
	mflo $3		
; Begin Active Region
		; handle first character independently
		; because also needs to assert BLANK
	lw $8, 4096($3)	; c = CHARRAM[i]
	addi $31, $0, 8	; wait 8
	sw $8, 16384($2)	; 0x4000 LOAD
				; sr = FONTRAM(c,line)
	sw $0, 16385($0)	; 0x4001 BLANK
	addi $4, $0, 0	; col=0
COLS:	addi $3, $3, 1	; i++
	lw $8, 4096($3)	; c = CHARRAM[i]
	addi $31, $0, 8	; wait 8
	sw $8, 16384($2)	; 0x4000 LOAD
				; sr = FONTRAM(c,line)
	addi $4, $4, 1	; col++
	slti $5, $4, 80	; if col < 80
	bne $5, $0, COLS 	;    goto COLS

	addi $31, $0, 1	; wait 1
	addi $31, $0, 16	; wait 16
	sw $0, 16385($0) 	; 0x4001 BLANK

	addi $2, $2, 1	; line++
	slti $5, $2, 16	; if line < 16
	bne $5, $0, LINES	;    goto LINES

	addi $1, $1, 1	; row++
	slti $5, $1, 30	; if row < 30
	bne $5, $0, ROWS	;    goto ROWS
; End Active Region

; Vertical Front Porch	
	addi $1, $0, 0	; i = 0
VFP:	addi $31, $0, 96	; wait 96
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $31, $0, 704	; wait 704
	sw $0, 16386($0)	; 0x4002 HSYNC
	addi $1, $1, 1	; i++
	slti $5, $1, 10	; if i < 10
	bne $5, $0, LOOP    	;    goto VFP
       j LOOP
	hlt


